//MD
//2021
// change AC output level more strong, from 10 level	





typedef unsigned char byte;
typedef unsigned int  word;
typedef unsigned long lword;

typedef unsigned char   u8;
typedef unsigned int    u16;
typedef unsigned long   u32;
typedef signed char     s8;
typedef signed int      s16;
typedef signed long     s32;

typedef unsigned char UINT8;

// ========================================================
#include <stdio.h>
#include <intrins.h>
#include "N79E81x.h"

#include "WDT.h"
#include "main.h"
#include "MD215_MCU_Define.h"
#include "MD215.h"

#include "MD215_TR.c"



/**********************************************************
**Name:    
**Function: 
**Input:    none
**Output:   none
**********************************************************/

//void Enabled_Brake_Function(void)
//{
//    PWMCON1 = 0x30;                    // PWM is running. PWM will be stopped when P0.2 is low level.
//}

    
/**********************************************************
**Name:    
**Function: 
**Input:    none
**Output:   none
**********************************************************/
//-----------------------------------------------------------------------------------------------------------
//void Enable_ADC_Interrupt(void)
//{
//    EADC = 1;
//    EA = 1;
//}
/**********************************************************
**Name:     PowerUpDelay




/*==================================================================*/
void main(void)
{ 
 

  Delayn(200);
  Init_MCU_Reg();
  InitPort();
  Init_MCU_RAM();
  timer0_init();
  timer2_init();
  
  Delayn(200);
  InitCC1101();
  SetCC1101();
  Delayn(20);
  MD210_sleep();
  Delayn(20);
 
 
  

  

   gb_unit_on_flag=0x01;
 

   
 

  InitCC1101();
  SetCC1101();
  Delayn(2);
  MD210_sleep();
  Delayn(2);
  gb_rf_windows=c_rfwindows;
  gb_rf_off_time=c_rf_off_time;
  gb_en_rx_flag=0x01;

  while(1)
  { 
    
    if(gb_en_rx_flag==1)
     {   

	     SpiWriteStorbe(SRX);		
	
         Delayn(1);

         while(gb_en_rx_flag==1)	 //wait windows timer over
	      {
              MD210_RxPacket(); 

	      }
	      gb_en_rx_flag=0;
	      MD210_sleep();
		 
	 }
	 
	Tx_signal();

    }
 }
/**********************************************************
**Name:     InitPort
**Function: Initialize Port
**Input:    none
**Output:   none
**********************************************************/

void InitPort(void)
{   
   //PxM1 PxM2=00 ׼˫ģʽ
   //         =01 ģʽ
   //         =10 ģʽ
   //         =11 ©ģʽ
	P0M1=0x94;//1001 0100
	P0M2=0X4B;//0100 1011

	P1M1=0X00;//0000 0000
	P1M2=0Xc7;//1100 0111
	
	
	P3M1&=0XFC;//1111 1100	
	P3M2|=0X03;//0000 0011	
	
	MOSI=0;
	nSEL=1;  


 
}
/**********************************************************

***********************************************************/
void Init_MCU_RAM(void)
{
	gb_rf_windows=8;
	gb_rf_off_time=16;
	gb_en_rx_flag=1;
	f_low_bat=0;

	lamp_on_cnt=0;
}	
/**********************************************************
ƣInit_MCU_Reg
ܣ
**********************************************************/
void Init_MCU_Reg(void)
{
	//DIVM=0X01;//5.5296MHZ	fsys=fosc/(2(DIVM+1))	@22.1184MHZ
 	    KBLS0 =0X00;//P04 as DC CHARGE and edge changed
	    KBLS1 =0X10;//KBLS1.4 : KBLS0.4=10 edge changed
	    		//P05 as key input(falling)
	                //KBLS1.5,KBLS0.5=00 Falling edge for key input

        KBIF = 0x00;//Clear KBF
	    KBIE = 0X30;//KB4(charge),KB5(KEY) EN INT 
        EA  = 1;    // Enable EA



//adc




}

/**********************************************************
**Name:     Init_PWM
**Function: pwm Initialization
**Input:    none
**Output:   none
**********************************************************/
void Init_PWM(void)
{
} 
/**********************************************************
**Name:     timer0_init
**Function: timer0 Initialization
**Input:    none
**Output:   none
**********************************************************/
void timer0_init(void)
{
    TMOD &= 0xF0;                   // Timer 0 mode 1 with hardware gate
    TMOD |= 0x01;                   // GATE0=0; C/T0#=0; M10=0; M00=1;
	//10ms
    //TH0 =(65536-10000)/256;	//TH0_Value;                // Initial values
    //TL0 = (65536-10000)%256;	//TL0_Value;

	//100us
	TH0 =(65536-100)/256;	//TH0_Value;                // Initial values
    TL0 = (65536-100)%256;	//TL0_Value;

    ET0 = 1;                        // Enable timer0 interrupt
    EA = 1;                         // Enable interrupts
    TR0 = 1;                        // Timer0 run
}


/**********************************************************
**Name:     timer2_init
**Function: timer2 Initialization
**Input:    none
**Output:   none
timer2 is 16bit count up timer
;fsys=11.0592mhz
;scale:1/32
;Td=32/11.0592=2.893519us
20000/Td=1AFF->6911 (dec)
**********************************************************/
void timer2_init(void)
{
    T2MOD = 0xb0;                       //LDEN=1,T2DIV=011. Enabled auto-reload and timer2 clock divider is 1/32
    TR2=0;
	CP_RL2=0;							//TIMER MODE
    TH2 =(65536-6911)/256;                         // Initial values
    TL2 =(65536-6911)%256;
    RCOMP2L = TL2 ;                      // Reload values initialize
    RCOMP2H = TH2 ;

	TR2=1;								//timer2 running
	ET2=1;								//enable timer2 interrupt
    EA = 1;                             // Enable interrupts
    
}



//-----------------------------------------------------------------------------------------------------------
void Timer0_ISR(void) interrupt 1   // Vector @  0x0B
{
	//1.09us
    TF0 = 0;                        // Reset timer0 interrupt flag (already done by hardware)
   	



}
//-----------------------------------------------------------------------------------------------------------
//-----------------------------------------------------------------------------------------------------------
void INT0_ISR(void) interrupt 0          // Vector @  0x03
{
    //P0 = 0xFF-1;
    IE0=0;
}

//-----------------------------------------------------------------------------------------------------------
void INT1_ISR(void) interrupt 2          // Vector @  0x13
{
    //P0 = 0xFF-3;
    IE1=0;
}
//-----------------------------------------------------------------------------------------------------------
void Timer1_ISR(void) interrupt 3        // Vector @  0x1B
{
    //P0 = 0xFF-4;
    TF1=0;
    
       
   
    
    
    
}

//-----------------------------------------------------------------------------------------------------------
void Timer2_ISR(void) interrupt 5        // Vector @  0x2B
{								   		//about 20ms
    
    TF2=0;
    if(gb_rf_windows!=0)
	{
	 gb_rf_windows--;
	 if(gb_rf_windows==0)
	    gb_en_rx_flag=0;
	  }
    
    if(gb_rf_off_time!=0)//&&(gb_rf_scan_flag==0))
	{
	   gb_rf_off_time--;
	   if(gb_rf_off_time==0)	  
          { gb_rf_windows=c_rfwindows; 
            gb_rf_off_time=c_rf_off_time;
		    gb_en_rx_flag=1;
		  }			
     }
   
}
//-----------------------------------------------------------------------------------------------------------
void I2C_ISR(void) interrupt 6           // Vector @  0x33
{
    P0 = 0xFF-7;
    SI=0;
}
//-----------------------------------------------------------------------------------------------------------
void KBI_ISR(void) interrupt 7           // Vector @  0x3B
{
    //P0 = 0xFF-8;
    //clr_KBIF0;
    KBIF = 0x00;                        // Clear KBF flag
    gb_KBI_int_flag=1;
 
	
}
//-----------------------------------------------------------------------------------------------------------
void BOD_ISR(void) interrupt 8           // Vector @  0x43
{
    //P0 = 0xFF-9;
//    BOF=0;
}
//-----------------------------------------------------------------------------------------------------------
void SPI_ISR(void) interrupt 9           // Vector @  0x4B
{
    //P0 = 0xFF-10;
//    clr_SPIF;
}
//-----------------------------------------------------------------------------------------------------------
//10K RC->100US  +/-50%
void WDT_ISR(void) interrupt 10          // Vector @  0x53
{							   			// 860ms
    //P0 = 0xFF-11;
	//for LED flashing
	//for learning mode timer
	EA=0;
	TA=0XAA;
	TA=0X55;
	WDCON0|=0X40;				//CLEAR WATCHDOG TIMER COUNTER
	//EA=1;

	//EA=0;
	TA=0XAA;
	TA=0X55;
	WDCON0&=0XDF;			//clear watchdog timer interrupt;
	EA=1;
	 // GLED=~GLED;

}
//-----------------------------------------------------------------------------------------------------------
void ADC_ISR(void) interrupt 11          // Vector @  0x5B
{
   // P0 = 0xFF-12;
    ADCI=0;


}
//-----------------------------------------------------------------------------------------------------------
void Capture_ISR(void) interrupt 12      // Vector @  0x63
{
    //P0 = 0xFF-13;
//    CAPF0=0;
}
//-----------------------------------------------------------------------------------------------------------
void PWM_Brake_ISR(void) interrupt 14    // Vector @  0x73
{
    //P0 = 0xFF-14;
//    BKF=0;
}
//-----------------------------------------------------------------------------------------------------------

       
     
 

/**********************************************************
**Name:    
**Function: 
**Input:    none
**Output:   none
**********************************************************/
 void Delayn(unsigned char tt)
{
	unsigned char i;
	unsigned char j;
	
	for(i=tt; i>0; i--)   //
	{
		for(j=250;j>0;j--)
		{
		 _nop_ ();
		 _nop_ ();
		 _nop_ ();
		 _nop_ ();
		_nop_ ();
		 _nop_ ();
		 _nop_ ();
		 _nop_ ();
	 }	
   }	 
}   

/**********************************************************
**Name:    
**Function: 
**Input:    none
**Output:   none
**********************************************************/
void Delayus(u16 ttt)
{
	for(;ttt>0; ttt--)   
	{
		 _nop_ ();
		 _nop_ ();
		
		
	 }	
   	 
}   







//===============================



//-----------------------------------------------------------------------------------------------------------
/*void Send_Data_To_PC (u8 c)
{
    while (!TI);
    TI = 0;
    SBUF = c;
} */
//--------







/*eof*/ 