
#ifndef __MD210_H
#define __MD210_H

void InitCC1101(void);
u8 CC1101StartUpSeq(void);
void SetCC1101(void);
void MD210_sleep(void);
void Tx_signal(void);

u8 HalfSpiCmd(u8 WrPara);
u8 SpiReadByte(u8 adr);
u8 SpiWriteByte(u8 adr, u8 WrPara);
u8 BurstRead(u8 adr, u8 *ptr, u8 length);
u8 BurstWrite(u8 adr, u8 const *ptr, u8 length);
void SpiWriteStorbe(u8 strobe);
void CC1100PinSPWDState( void );
void CC1100PinSTXState(void);
void CC1100PinSidleState(void);
void CC1100PinSRXState(void);
void TestTxMode (void);
void TestRxMode(void);
void TXRX_MODE(void);
void MD210_RxPacket(void);





#endif