
#ifndef __MAIN_H
#define __MAIN_H


void InitPort(void);
void Init_MCU_Reg(void);
void Init_MCU_RAM(void);

void timer0_init(void);
void timer0_init_ac(void);
void timer1_init(void);
void timer2_init(void);

void Uart_init(void);
void Init_WDT(void);

void Init_PWM(void);  
void Init_ADC(void);
 

void Timer0_ISR(void); 

void Timer1_ISR(void);
void Timer2_ISR(void);
void INT0_ISR(void);
void INT1_ISR(void);

//void I2C_ISR(void);
void KBI_ISR(void);
//void BOD_ISR(void);
//void SPI_ISR(void);
void WDT_ISR(void);
void ADC_ISR(void);
//void Capture_ISR(void);
//void PWM_Brake_ISR(void);

void Stop_PWM(void);

void key_scan(void);

void Charg_Detect(void);
void LowBat_Detect(void);

void key_tone(void);
void DoLeMi_tone(void);
void MiLeDo_tone(void);
void bz_output(void);
void ac_output(void);
void mo_output(void);

void Close_ISP(void);
void Enable_ISP(void);
void Trigger_ISP(void);
void FLASH_Read_ID(void);
void FLASH_Program_ID(void);
void FLASH_PAGE_Erase(void);

void Delayus(u16 ttt);
void Delayn(unsigned char tt);
void BPS_Delay(void);
void SendOut(unsigned char tx_buf);


#endif